using System;
using Server.Network;
using Server.Prompts;
using Server.Items;
using Server.Targeting;

namespace Server.Items
{
	public class CastRecovtarget : Target // Create our targeting class (which we derive from the base target class)
	{
		private CastRecovPvPDeed m_Deed;

		public CastRecovtarget( CastRecovPvPDeed deed ) : base( 1, false, TargetFlags.None )
		{
			m_Deed = deed;
		}

		protected override void OnTarget( Mobile from, object target )
		{
			if ( target is BaseWeapon )
			{
				BaseWeapon item = (BaseWeapon)target;
					if( item.RootParent != from ) // Make sure its in their pack or they are wearing it
					{
						from.SendMessage( "That item must be in your possession for you to enhance!");
					}
					else
					{
						(item).Attributes.CastRecovery += 1;
						from.SendMessage( "You have increased the cast recovery attribute by 1 on the item." );

						m_Deed.Delete();
					}
			}

			else if (target is BaseArmor)
			{
				BaseArmor item = (BaseArmor)target;
					if( item.RootParent != from ) // Make sure its in their pack or they are wearing it
					{
						from.SendMessage( "That item must be in your possession for you to enhance!");
					}
					else
					{
						(item).Attributes.CastRecovery += 1;
						from.SendMessage( "You have increased the cast recovery attribute by 1 on the item." );

						m_Deed.Delete();
					}
			}

			else if (target is BaseJewel)
			{
				BaseJewel item = (BaseJewel)target;
					if( item.RootParent != from ) // Make sure its in their pack or they are wearing it
					{
						from.SendMessage( "That item must be in your possession for you to enhance!");
					}
					else
					{
						(item).Attributes.CastRecovery += 1;
						from.SendMessage( "You have increased the cast recovery attribute by 1 on the item." );

						m_Deed.Delete();
					}
			}

			else if (target is BaseClothing)
			{
				BaseClothing item = (BaseClothing)target;
					if( item.RootParent != from ) // Make sure its in their pack or they are wearing it
					{
						from.SendMessage( "That item must be in your possession for you to enhance!");
					}
					else
					{
						(item).Attributes.CastRecovery += 1;
						from.SendMessage( "You have increased the cast recovery attribute by 1 on the item." );

						m_Deed.Delete();
					}
			}	

			if ( target is Spellbook )
			{
				Spellbook item = (Spellbook)target;
					if( item.RootParent != from ) // Make sure its in their pack or they are wearing it
					{
						from.SendMessage( "That item must be in your possession for you to enhance!");
					}
					else
					{
						(item).Attributes.CastRecovery += 1;
						from.SendMessage( "You have increased the cast recovery attribute by 1 on the item." );

						m_Deed.Delete();
					}
			}	
						
			else
			{
				from.SendMessage( "You can not use this on that!" );
			}
		}
	}

	public class CastRecovPvPDeed : Item
	{
		[Constructable]
		public CastRecovPvPDeed() : base( 0x14F0 )
		{
			Weight = 1.0;
			Hue = 3;
			Name = "Equipment Enhancement Deed - Cast Recovery [+1]";
			LootType = LootType.Blessed;
		}

		public CastRecovPvPDeed( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			LootType = LootType.Blessed;

			int version = reader.ReadInt();
		}

		public override bool DisplayLootType{ get{ return false; } }

		public override void OnDoubleClick( Mobile from )
		{
			if ( !IsChildOf( from.Backpack ) )
			{
				 from.SendLocalizedMessage( 1042001 );
			}
			else
			{
				from.SendMessage( "What item would you like to enhance?" ); 
				from.Target = new CastRecovtarget( this );
			 }
		}	
	}
}



